import 'package:flutter/material.dart';
import 'package:repo_on_pub/src/bloc.dart';
import 'package:repo_on_pub/src/endereco_model.dart';


class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {

  MyHomePageBloc bloc = MyHomePageBloc();

  @override
  void dispose() {
    bloc.dispose();
    super.dispose();
  }

  @override 
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Padding(
        padding: EdgeInsets.all(8.0),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          children: <Widget>[
            TextField(
              onChanged: (value)  {
                bloc.input.add(value);
              },
              keyboardType: TextInputType.number,
              decoration: InputDecoration(
                border: OutlineInputBorder(),
                hintText: 'Digite seu CEP'
              ),
            ),
            SizedBox(height: 15.0,),
            StreamBuilder<EnderecoModel>(
              stream: bloc.output,
              initialData: EnderecoModel(bairro: 'Sem bairro'),
              builder: (context, snapshot) {

                if (snapshot.hasError) {
                  return Text(
                    'Erro na pesquisa',
                    style: TextStyle(color: Colors.green),
                  );
                }

                EnderecoModel model = snapshot.data;
                return Center(
                  child: Text('Bairro: ${model.bairro}'),
                );
              }
            )
          ],
        ),
        
      )
    );
  }
}
